---
Name: "kube-lib-kubectl-install"
Description: "Install KubeCTL"
Documentation: |
  Installs KubeCTL on machine.

RequiredParams:
  - kube-lib/kubectl-version
OptionalParams:
  - kube-lib/kube-config
ExtraClaims:
  - scope: "files"
    action: "*"
    specific: "*"
Templates:
  - Name: "kube.config"
    Path: "kube.config"
    Meta:
      OS: linux
    Contents: |
      {{if .ParamExists "kube-lib/kube-config"}}{{ .Param "kube-lib/kube-config" | toPrettyJson }}{{end}}
  - Name: "kubectl-install.sh"
    Path: ""
    Meta:
      OS: linux
    Contents: |
      #!/usr/bin/env bash

      {{ template "setup.tmpl" . }}
      {{ template "download-tools.tmpl" . }}

      echo "--- starting shared kubectl install ---"

      export KUBECONFIG="./kube.config"
      if [[ -f $KUBECONFIG ]] ; then
        echo "  verified $KUBECONFIG exists"
      else
        echo "ERROR: calling Task MUST create $KUBECONFIG file"
        exit 1
      fi

      echo "Checking kubectl version"
      if kubectl version ; then
        echo "  skipping install: kubectl detected"
      else
        INSTALL_DIR=/usr/bin
        BINARIES="$INSTALL_DIR/kubectl"

        echo "  not detected...download $BINARIES based on kube-lib/kubectl-version"
        {{ $cachesource := "kube-lib/kubectl-version" }}
        OS={{if .Machine.OS}}{{ .Machine.OS }}{{else}}"linux"{{end}}
        ARCH="{{ .Machine.Arch }}"
        {{ $arch := list "linux" .Machine.Arch | join "-" }}
        {{ $file := .Param $cachesource }}
        {{ $source := get $file $arch }}
        drp_cache "{{ get $file "name" }}" "{{ get $file "version" }}" "$OS" "$ARCH" "{{ get $source "url" }}" "{{ get $source "sha256sum" }}" "{{ get $source "explode" }}"
        mv "{{ get $file "name" }}" $BINARIES
        chmod +x $BINARIES
        echo "  verify $BINARIES version"
        kubectl version --client=true
      fi

      echo "Done"
      exit 0
Meta:
  icon: "download"
  color: "brown"
  title: "Community Content"
  copyright: "RackN 2020"
